osg::Billboard Class Reference

`#include <Billboard>`

Inheritance diagram for osg::Billboard:

## Public Types

enum | Mode { POINT_ROT_EYE , POINT_ROT_WORLD , AXIAL_ROT }
typedef std::vector< Vec3 > | PositionList
Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| Billboard ()
| Billboard (const Billboard &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Billboard)
void | setMode (Mode mode)
Mode | getMode () const
void | setAxis (const Vec3 &axis)
const Vec3 & | getAxis () const
void | setNormal (const Vec3 &normal)
const Vec3 & | getNormal () const
void | setPosition (unsigned int i, const Vec3 &pos)
const Vec3 & | getPosition (unsigned int i) const
void | setPositionList (PositionList &pl)
PositionList & | getPositionList ()
const PositionList & | getPositionList () const
virtual bool | addDrawable (Drawable *gset)
virtual bool | addDrawable (Drawable *gset, const Vec3 &pos)
virtual bool | removeDrawable (Drawable *gset)
bool | computeMatrix (Matrix &modelview, const Vec3 &eye_local, const Vec3 &pos_local) const
virtual BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Geode
| Geode ()
| Geode (const Geode &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Geode)
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
template<class T>
bool | addDrawable (const ref_ptr< T > &drawable)
template<class T>
bool | removeDrawable (const ref_ptr< T > &drawable)
virtual bool | removeDrawables (unsigned int i, unsigned int numDrawablesToRemove=1)
virtual bool | replaceDrawable (Drawable *origDraw, Drawable *newDraw)
template<class T, class R>
bool | replaceDrawable (const ref_ptr< T > &origDraw, const ref_ptr< R > &newDraw)
virtual bool | setDrawable (unsigned int i, Drawable *drawable)
template<class T>
bool | setDrawable (unsigned int i, const ref_ptr< T > &drawable)
unsigned int | getNumDrawables () const
Drawable * | getDrawable (unsigned int i)
const Drawable * | getDrawable (unsigned int i) const
bool | containsDrawable (const Drawable *drawable) const
template<class T>
bool | containsDrawable (const ref_ptr< T > &drawable) const
unsigned int | getDrawableIndex (const Drawable *drawable) const
template<class T>
unsigned int | getDrawableIndex (const ref_ptr< T > &drawable) const
void | compileDrawables (RenderInfo &renderInfo)
const BoundingBox & | getBoundingBox () const
Public Member Functions inherited from osg::Group
| Group ()
| Group (const Group &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Node (osg, Group)
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual void | traverse (NodeVisitor &nv)
virtual bool | addChild (Node *child)
template<class T>
bool | addChild (const ref_ptr< T > &child)
virtual bool | insertChild (unsigned int index, Node *child)
template<class T>
bool | insertChild (unsigned int index, const ref_ptr< T > &child)
virtual bool | removeChild (Node *child)
template<class T>
bool | removeChild (const ref_ptr< T > &child)
bool | removeChild (unsigned int pos, unsigned int numChildrenToRemove=1)
virtual bool | removeChildren (unsigned int pos, unsigned int numChildrenToRemove)
virtual bool | replaceChild (Node *origChild, Node *newChild)
template<class T, class R>
bool | replaceChild (const ref_ptr< T > &origChild, const ref_ptr< R > &newChild)
virtual unsigned int | getNumChildren () const
virtual bool | setChild (unsigned int i, Node *node)
Node * | getChild (unsigned int i)
const Node * | getChild (unsigned int i) const
bool | containsNode (const Node *node) const
template<class T>
bool | containsNode (const ref_ptr< T > &node) const
unsigned int | getChildIndex (const Node *node) const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int maxSize)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Types

enum | AxisAligned { AXIAL_ROT_X_AXIS =AXIAL_ROT+1 , AXIAL_ROT_Y_AXIS , AXIAL_ROT_Z_AXIS , POINT_ROT_WORLD_Z_AXIS , CACHE_DIRTY }

## Protected Member Functions

virtual | ~Billboard ()
void | updateCache ()
Protected Member Functions inherited from osg::Geode
virtual | ~Geode ()
Protected Member Functions inherited from osg::Group
virtual | ~Group ()
virtual void | childRemoved (unsigned int, unsigned int)
virtual void | childInserted (unsigned int)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

Mode | _mode
Vec3 | _axis
Vec3 | _normal
Matrix | _rotateNormalToZAxis
PositionList | _positionList
int | _cachedMode
Vec3 | _side
Protected Attributes inherited from osg::Geode
osg::BoundingBox | _bbox
Protected Attributes inherited from osg::Group
NodeList | _children
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Billboard is a derived form of Geode that orients its osg::Drawable children to face the eye point. Typical uses include trees and particle explosions.

## Member Typedef Documentation

## PositionList

typedef std::vector<Vec3> osg::Billboard::PositionList

Type definition for pivot point position list.

## Member Enumeration Documentation

## AxisAligned

enum osg::Billboard::AxisAligned

protected

Enumerator
AXIAL_ROT_X_AXIS |
AXIAL_ROT_Y_AXIS |
AXIAL_ROT_Z_AXIS |
POINT_ROT_WORLD_Z_AXIS |
CACHE_DIRTY |

## Mode

enum osg::Billboard::Mode

Enumerator
POINT_ROT_EYE |
POINT_ROT_WORLD |
AXIAL_ROT |

## Constructor & Destructor Documentation

## Billboard() [1/2]

osg::Billboard::Billboard | ( |  | ) |

Referenced by Billboard(), and META_Node().

## Billboard() [2/2]

osg::Billboard::Billboard | ( | const Billboard & | ,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

Copy constructor using CopyOp to manage deep vs shallow copy.

References Billboard(), and osg::CopyOp::SHALLOW_COPY.

## ~Billboard()

virtual osg::Billboard::~Billboard | ( |  | ) |

protected virtual

## Member Function Documentation

## addDrawable() [1/2]

virtual bool osg::Billboard::addDrawable | ( | Drawable * | gset | ) |

virtual

Add a Drawable with a default position of Vec3(0,0,0). Call the base-class Geode::addDrawble() to add the given Drawable gset as a child. If Geode::addDrawable() returns true, add the default position to the pivot point position list and return true. Otherwise, return false.

Reimplemented from osg::Geode.

## addDrawable() [2/2]

virtual bool osg::Billboard::addDrawable | ( | Drawable * | gset,
|  | const Vec3 & | pos )

virtual

Add a Drawable with a specified position. Call the base-class Geode::addDrawble() to add the given Drawable gset as a child. If Geode::addDrawable() returns true, add the given position pos to the pivot point position list and return true. Otherwise, return false.

## computeBound()

virtual BoundingSphere osg::Billboard::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Geode.

## computeMatrix()

bool osg::Billboard::computeMatrix | ( | Matrix & | modelview,
|  | const Vec3 & | eye_local,
|  | const Vec3 & | pos_local ) const

## getAxis()

const Vec3 & osg::Billboard::getAxis | ( |  | ) | const

inline

Get the rotation axis.

References _axis.

## getMode()

Mode osg::Billboard::getMode | ( |  | ) | const

inline

Get the billboard rotation mode.

References _mode.

## getNormal()

const Vec3 & osg::Billboard::getNormal | ( |  | ) | const

inline

Get the front face direction normal.

References _normal.

## getPosition()

const Vec3 & osg::Billboard::getPosition | ( | unsigned int | i | ) | const

inline

Get the specified child Drawable's position.

References _positionList.

## getPositionList() [1/2]

PositionList & osg::Billboard::getPositionList | ( |  | ) |

inline

Get the list of pivot point positions.

References _positionList.

## getPositionList() [2/2]

const PositionList & osg::Billboard::getPositionList | ( |  | ) | const

inline

Get a const list of pivot point positions.

References _positionList.

## META_Node()

osg::Billboard::META_Node | ( | osg | ,
|  | Billboard | )

References Billboard().

## removeDrawable()

virtual bool osg::Billboard::removeDrawable | ( | Drawable * | gset | ) |

virtual

Remove a Drawable and its associated position. If gset is a child, remove it, decrement its reference count, remove its pivot point position. and return true. Otherwise, return false.

Reimplemented from osg::Geode.

## setAxis()

void osg::Billboard::setAxis | ( | const Vec3 & | axis | ) |

Set the rotation axis for the billboard's child Drawables. Only utilized when mode==AXIAL_ROT.

## setMode()

void osg::Billboard::setMode | ( | Mode | mode | ) |

Set the billboard rotation mode.

## setNormal()

void osg::Billboard::setNormal | ( | const Vec3 & | normal | ) |

This normal defines child Drawables' front face direction when unrotated.

## setPosition()

void osg::Billboard::setPosition | ( | unsigned int | i,
|  | const Vec3 & | pos )

inline

Set the specified child Drawable's position.

References _positionList.

## setPositionList()

void osg::Billboard::setPositionList | ( | PositionList & | pl | ) |

inline

Set the list of pivot point positions.

References _positionList.

## updateCache()

void osg::Billboard::updateCache | ( |  | ) |

protected

## Member Data Documentation

## _axis

Vec3 osg::Billboard::_axis

protected

Referenced by getAxis().

## _cachedMode

int osg::Billboard::_cachedMode

protected

## _mode

Mode osg::Billboard::_mode

protected

Referenced by getMode().

## _normal

Vec3 osg::Billboard::_normal

protected

Referenced by getNormal().

## _positionList

PositionList osg::Billboard::_positionList

protected

Referenced by getPosition(), getPositionList(), getPositionList(), setPosition(), and setPositionList().

## _rotateNormalToZAxis

Matrix osg::Billboard::_rotateNormalToZAxis

protected

## _side

Vec3 osg::Billboard::_side

protected

The documentation for this class was generated from the following file:

- Billboard